package ir_graph;

import java.util.Hashtable;



public abstract class IRNode {

	IRNode header;
	Hashtable<String, IRNode> subBlock;
	
	IRNode get(String name)
	{
		// check children
		if (subBlock.containsKey(name))
		{
			return subBlock.get(name);
		}
		
		// check current level (the children of the parent)
		if (header.subBlock.containsKey(name))
		{
			return header.subBlock.get(name);
		}
		
		throw new SymbolException("Undefined symbol.");
	}

	public String loc()
	{
		return "";
	}
}
