package parsing;



public class Stream
{
	public final String str;
	public final SrcLoc loc;

	public Stream(String str, SrcLoc loc)
	{
		this.str = str;
		this.loc = loc;
	}

	public Stream(String str, int line)
	{
		this(str, new SrcLoc(line, 1));
	}
	

	public Stream after(WithLoc wl)
	{
		if (wl.end.caret < loc.caret)
			throw new RuntimeException("Internal error: " + wl.end + " < " + loc);
		
		return after(wl.end.caret - loc.caret + 1);
	}

	public Stream after(int skipped)
	{
		while (skipped < str.length() && (str.charAt(skipped) == ' ' | str.charAt(skipped) == '\t'))
			skipped++;

		String after_str = str.substring(skipped);
		return new Stream(after_str, loc.after(skipped));
	}

	public String toString()
	{
		return loc.toString() + ": " + str;
	}

}
