package parsing;

import java.util.*;

public class Tree<T>
{
	public List<Tree<T>> children = new LinkedList<Tree<T>>();
	public T content;


	public String toString()
	{
		String result = content.toString() + "\n";
		for (Tree<T> child : children)
			result += indent(child.toString());
			
		return result;
		
	}
	
	public String indent(String str)
	{
		String result = "";
		String[] lines = str.split("\\r?\\n");
		for (String s : lines)
			result += "\t" + s + "\n";
		
		return result;
	}

	public <R> Tree<R> transform(Functor<T,R> fun)
	{
		Tree<R> tree = new Tree<R>();
		
		tree.content = fun.apply(this.content);
		
		for (Tree<T> child : this.children)
		{
			tree.children.add(child.transform(fun));
		}

		return tree;
	}
}
