package syntax.expressions;
import parsing.*;


public class Symbol extends Value
{
	public String name;
	public Expression target;

	Symbol(String name, SrcLoc loc)
	{
		this.name = name;
		start = loc;
		end = loc.after(name.length() - 1);
	}

	public static Symbol read(Stream stream)
	{
		String sym = StreamHandler.grabToken(stream);
		if (sym.matches("-?~[0-9].*") | sym.matches(".*[.,;\\\"(){}\\[\\]].*") | sym.matches("'.*"))
		{
			throw new ParsingException(stream, "Invalid symbol");
		}
		else if(  sym.equals("=") 
				| sym.equals("->")
				| sym.equals(":")
				| sym.equals("::")
				| sym.equals("function")
				| sym.equals("case") 
				| sym.equals("of") 
				| sym.equals("if") 
				| sym.equals("else") 
				| sym.equals("data") 
				| sym.equals("type") 
				| sym.equals("as") 
				| sym.equals("in") 
				)
		{
			throw new ParsingException(stream, "Keyword is invalid as symbol");
		}
		else
			return new Symbol(sym, stream.loc);
	}

	
	public Value eval()
	{
		return this;
	}
	
	
	public String toString()
	{
		return "" + name;
	}

	public boolean equals(Symbol other)
	{
		return this.name.equals(other.name);
	}
}
 
