package syntax.expressions;
import parsing.*;


public class VString extends PrimitiveValue
{
	String string;


	VString(String string, SrcLoc start, SrcLoc end)
	{
		super("String", string.getBytes(), start, end);

		this.string = string;
	}

	public static VString read(Stream stream)
	{
		String str = stream.str;

		if (str.length() == 0)
			throw new ParsingException(stream, "Unexpected end of line");
		
		if (str.charAt(0) != '"')
			throw new ParsingException(stream, "String expected");
		else
		{
			int taken = 1;
		
			while (taken < str.length() && str.charAt(taken) != '"')
				taken++;
			
			if (taken == str.length())
				throw new ParsingException(stream, "Closing quotes missing");
			
			String string = str.substring(1, taken);
			return new VString(string, stream.loc, stream.loc.after(string.length() + 1));
		}
	}


	public String toString()
	{
		return "\"" + string + "\"";
	}
}
