package syntax.expressions;
import parsing.*;


public abstract class Value extends Expression
{
	
	
	public Value eval()
	{
		return this;
	}
	
	
	public static Value read(Stream stream)
	{
		try {
			return StructuredValue.read(stream);
		}
		catch (ParsingException pe1) {
			try {
				return PrimitiveValue.read(stream);
			}
			catch (ParsingException pe2) {
				try {
					return Symbol.read(stream);
				}
				catch (ParsingException pe3) {
					try {
						return Tuple.readExpressionTuple(stream);
					}
					catch (ParsingException pe4) {	
						ParsingException def = new ParsingException(stream, "Value could not be matched.");
						throw ParsingException.latest(new ParsingException[] {def, pe1, pe2, pe3, pe4});
					}
				}
			}
		}
	}

}
