package syntax.headers;

import parsing.*;
import syntax.expressions.*;


public class CaseClause extends Header {

	public Expression condition;
	public RightHandSide result;
	
	
	public CaseClause(Expression condition, RightHandSide result)
	{
		this.condition = condition;
		this.result = result;
		this.start = condition.start;
		this.end = result.end;
	}
	
	
	public static CaseClause read(Stream stream)
	{
		Expression condition = Expression.read(stream, 0);
		Token arrow = Token.read("->", stream.after(condition));
		RightHandSide result = RightHandSide.read(stream.after(arrow));
		
		return new CaseClause(condition, result);
	}
}
