package syntax.headers;
import parsing.*;
import syntax.expressions.*;

public class Definition extends Header
{
	public Symbol symbol;
	public RightHandSide rhs;

	public Definition(Symbol symbol, RightHandSide rhs)
	{
		this.symbol = symbol;
		this.rhs = rhs;
		this.start = symbol.start;
		this.end = rhs.end;
	}
	
	
	public static Definition read(Stream stream)
	{
		Symbol symbol = Symbol.read(stream);
		Token eq = Token.read("=", stream.after(symbol));
		RightHandSide expr = RightHandSide.read(stream.after(eq));
		
		return new Definition(symbol, expr);
	}
	

	
	public Value eval()
	{
		return rhs.eval();
	}

	public String toString()
	{
		return "" + symbol + " = " + rhs;
	}
}
