package syntax.headers;

import parsing.*;
import syntax.expressions.*;


import java.util.*;


public class NamedFunctionDef extends Header
{
	public Symbol name;
	public Vector<Symbol> params;
	public Expression result;

	
	
	
	public static NamedFunctionDef read(Stream stream)
	{
		Token         fun    = Token.read("function", stream);
		Symbol        name   = Symbol.read(stream.after(fun));
		
		Tuple<Symbol> paramsTuple = Tuple.readSymbolTuple(stream.after(name));
		Token         arrow  = Token.read("->", stream.after(paramsTuple));
		Expression    result = Expression.read(stream.after(arrow), 0);
		
		NamedFunctionDef funDef = new NamedFunctionDef();
		
		funDef.start = fun.start;
		funDef.end = result.end;
		
		funDef.name = name;
		funDef.params = paramsTuple.members;
		funDef.result = result;
		
		return funDef;
	}
	
	public Value eval()
	{
		return result.eval();
	}

	public String toString()
	{
		return "function " + name + Tuple.asString(params) + " -> " + result;
	}

}
